//+------------------------------------------------------------------+
//| Collaboration: Dolly + Isakas + Nina System (DIN)                |
//|                                             KusKus_EA.mq4        |
//|                                              Copyright  2007    |
//|    Written by Robert Hill for Forex-tsd group                    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Robert Hill"
#property link      "http://www.forex-tsd.com/"
#include <stdlib.mqh>

#define UP 1
#define DOWN 2

// Trend indicators
#define NO_FILTER 0
#define MACD_FILTER 1
#define DIGI_FILTER 2
#define MACD_DIGI_FILTER 3
#define EMA_FILTER 4
#define LSMA_FILTER 5
#define ITREND_FILTER 6
#define HMA_FILTER 7


//+---------------------------------------------------+
//|Account functions                                  |
//+---------------------------------------------------+
extern bool AccountIsMini = true;      // Change to true if trading mini account
//+---------------------------------------------------+
//|Money Management                                   |
//+---------------------------------------------------+
extern bool    MoneyManagement = true; // Change to false to shutdown money management controls.
                                       // Lots = 1 will be in effect and only 1 lot will be open regardless of equity.
extern double  TradeSizePercent = 10;  // Change to whatever percent of equity you wish to risk.
extern double  Lots = 0.1;             // standard lot size. 
extern double  MaxLots = 100;
//+---------------------------------------------------+
//|Profit controls                                    |
//+---------------------------------------------------+
extern double  StopLoss = 30;          // Maximum pips willing to lose per position.
extern bool    UseTrailingStop = false;
extern double  TrailingStop = 15;      // Change to whatever number of pips you wish to trail your position with.
extern double  Margincutoff = 500;     // Expert will stop trading if equity level decreases to that level.
extern int     TakeProfit = 15;        // Maximum profit level achieved.
extern int     Slippage = 10;          // Possible fix for not getting filled or closed    

//+---------------------------------------------------+
//|Indicator Variables                                |
//| Change these to try your own system               |
//| or add more if you like                           |
//+---------------------------------------------------+

extern string  Expert_Name    = "---- DIN_v2 ----";
extern int useTrend = 1;
extern int useHeikenAshi = 1;
extern int useBBStop = 1;
extern int useFish = 1;
extern int useStepMA = 1;
extern int useEMA = 0;

extern int useTrendExit = 0;
extern int useHeikenAshiExit = 1;
extern int useBBStopExit = 0;
extern int useFishExit = 0;
extern int useStepMAExit = 1;

extern string  s1="BBandsStop settings";
extern string  s1a=" Usefunction = 0 uses iCustom";
extern string  s1b=" UseFunction = 1 uses function";
extern int     UseFunction = 0;
extern int     Length=20;      // Bollinger Bands Period
extern int     Deviation=2;    // Deviation
extern double  MoneyRisk=1.00; // Offset Factor

extern string  s2="Fisher settings";
extern int     RangePeriods=35;
extern double  PriceSmoothing=0.3;    // =0.67 bei Fisher_m10 
extern double  IndexSmoothing=0.3;    // =0.50 bei Fisher_m10

extern string  s3="Heiken_Ashi_Ma settings";
extern int     MaMethod  = 1;
extern int     MaPeriod = 15;

extern string  s4="EMA setting for entry";
extern int     EntryMA_Period = 50;

extern int     Signal_TimeFrame = 30;

extern string  dstr0 = " 4 Hr Trend";
extern string  dstr1 = " 0 = None";
extern string  dstr2 = " 1 = MACD";
extern string  dstr3 = " 2 = DigiStoch";
extern string  dstr4 = " 3 = MACD & DigiStoch";
extern string  dstr5 = " 4 = EMA(14)";
extern string  dstr6 = " 5 = LSMA(18)";
extern string  dstr7 = " 6 = ITrend(26)";
extern string  dstr8 = " 7 = HMA(16)";
extern int     T4_Method = 7;

extern string  sD=" 4 Hr GMACD settings";
extern int     T4_FastEMA = 8;
extern int     T4_SlowEMA = 17;
extern int     T4_SignalSMA = 9;

extern string  sDS=" 4 Hr DigiStoch settings";
extern int     T4_K_period = 8;
extern int     T4_D_period = 3;
extern int     T4_S_period = 3;

extern string  ss=" 4 Hr MA settings";
extern int     T4_Period=6;
extern double  T4_Threshold=20;
extern int     T4_PrevShift=3;
extern int     T4_CurShift=1;
extern int     T4_TimeFrame = 240;
extern int     T4_SignalCandle = 0;

extern string  fstr0 = " 1 Hr Trend";
extern string  fstr1 = " 0 = None";
extern string  fstr2 = " 1 = MACD";
extern string  fstr3 = " 2 = DigiStoch";
extern string  fstr4 = " 3 = MACD & DigiStoch";
extern string  fstr5 = " 4 = EMA(14)";
extern string  fstr6 = " 5 = LSMA(18)";
extern string  fstr7 = " 6 = ITrend(26)";
extern string  fstr8 = " 7 = HMA(16)";
extern int     T1_Method = 0;

extern string  s5=" 1 Hr GMACD";
extern int     T1_FastEMA = 8;
extern int     T1_SlowEMA = 17;
extern int     T1_SignalSMA = 9;

extern string  s5S=" 1 Hr DigiStoch settings";
extern int     T1_K_period = 8;
extern int     T1_D_period = 3;
extern int     T1_S_period = 3;

extern string  st=" 1 Hr MA settings";
extern int     T1_Period=6;
extern double  T1_Threshold=10;
extern int     T1_PrevShift=3;
extern int     T1_CurShift=1;
extern int     T1_TimeFrame = 60;
extern int     T1_SignalCandle = 0;


extern string  s6="//====HMA settings====//";
extern int     method = 0;
extern int     price = 0;

extern bool    UseTradingHours = true;
extern bool    TradeAsianMarket = true;
extern int     StartHour1 = 0;       // Start trades after time
extern int     StopHour1 = 3;      // Stop trading after time
extern bool    TradeEuropeanMarket = true;
extern int     StartHour2 = 9;       // Start trades after time
extern int     StopHour2 = 11;      // Stop trading after time
extern bool    TradeNewYorkMarket = false;
extern int     StartHour3 = 15;       // Start trades after time
extern int     StopHour3 = 17;      // Stop trading after time


//+---------------------------------------------------+
//|General controls                                   |
//+---------------------------------------------------+
string setup;
double lotMM;
int TradesInThisSymbol;
int MagicNumber;
bool YesStop;

//+---------------------------------------------------+
//|  Indicator values for signals and filters         |
//|  Add or Change to test your system                |
//+---------------------------------------------------+
double haOpen, haClose;
double LineMin, LineMid;
double Fish;
double BBStopUp, BBStopDown;

// variables used byBBStop function
int    Trend=0, PrevTrend=0;
double smin=0,smax=0,smin1=0,smax1=0,bsmin=0,bsmax=0,bsmin1=0,bsmax1=0,DeltaLong=0,DeltaShort=0;

// variables used for trend
double  macd_H4, macd_HH4;
double macd_H1, macd_HH1;
double stoch_main_h4, stoch_sig_h4;
double stoch_main_h1, stoch_sig_h1;
double MACurrent, MAPrevious;

 int SignalCandle = 1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   
	MagicNumber = 3000 + func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period()); 

   setup="DIN_v2" + Symbol() + "_" + func_TimeFrame_Val2String(func_TimeFrame_Const2Val(Period()));
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//| The functions from this point to the start function are where    |
//| changes are made to test other systems or strategies.            |
//|+-----------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom Indicators                                                |
//+------------------------------------------------------------------+

//===================================================================
//                                                    EMA_Angle.mq4 
//                                                          jpkfox
//
// You can use this indicator to measure when the EMA angle is
// "near zero". AngleTreshold determines when the angle for the
// EMA is "about zero": This is when the value is between
// [-AngleTreshold, AngleTreshold] (or when the histogram is red).
//   EMAPeriod: EMA period 
//   AngleTreshold: The angle value is "about zero" when it is
//     between the values [-AngleTreshold, AngleTreshold].
//   StartEMAShift: The starting point to calculate the 
//     angle. This is a shift value to the left from the
//     observation point. Should be StartEMAShift > EndEMAShift.
//   StartEMAShift: The ending point to calculate the
//     angle. This is a shift value to the left from the
//     observation point. Should be StartEMAShift > EndEMAShift.
//
//  Return 1 for up OK
//  Return -1 for down OK
//  Return 0 for too flat
//===================================================================
double MA_Angle( int PrevShift, int CurShift, double fPrevMA, double fCurMA)
{
   double fAngle, mFactor;
   string Sym;
   int ShiftDif;
   
   mFactor = 100000.0;
   Sym = StringSubstr(Symbol(),3,3);
   if (Sym == "JPY") mFactor = 1000.0;
   ShiftDif = PrevShift-CurShift;
   mFactor /= ShiftDif; 

    fAngle = mFactor * (fCurMA - fPrevMA)/2.0;

    return(fAngle);
}



//+------------------------------------------------------------------------+
//| LSMA - Least Squares Moving Average function calculation               |
//| LSMA_In_Color Indicator plots the end of the linear regression line    |
//+------------------------------------------------------------------------+

double fLSMA(int TimeFrame, int myRperiod, int shift)
{
   int i;
   double sum;
   int length;
   double lengthvar;
   double tmp;
   double wt;

   length = myRperiod;
 
   sum = 0;
   for(i = length; i >= 1  ; i--)
   {
     lengthvar = length + 1;
     lengthvar /= 3;
     tmp = 0;
     tmp = ( i - lengthvar)*iClose(NULL, TimeFrame,length-i+shift);
     sum+=tmp;
    }
    wt = sum*6/(length*(length+1));
    
    return(wt);
}

bool CheckHeikenAshi(int cmd)
{
   haOpen = iCustom(NULL, Signal_TimeFrame, "Heiken_Ashi_Ma",MaMethod,MaPeriod,2,1);
   haClose = iCustom(NULL, Signal_TimeFrame, "Heiken_Ashi_Ma",MaMethod,MaPeriod,3,1);
   switch (cmd)
   {
     case OP_BUY : if (haOpen < haClose) return(true);
                   break;
     case OP_SELL : if (haOpen > haClose) return(true);
   }
   
   return(false);
}

bool CheckStepMA(int cmd)
{
   LineMin = iCustom(NULL, Signal_TimeFrame, "Hist_StepMA_Stoch_KV1_Ex_03",0,1);
   LineMid = iCustom(NULL, Signal_TimeFrame, "Hist_StepMA_Stoch_KV1_Ex_03",1,1);
   switch (cmd)
   {
     case OP_BUY : if (LineMid > 0) return(true);
                   break;
     case OP_SELL : if (LineMin < 0) return(true);
   }
   
   return(false);
}

bool CheckFish(int cmd)
{
   Fish = iCustom(NULL, Signal_TimeFrame, "Fisher_m11",RangePeriods,PriceSmoothing, IndexSmoothing,0,1);
   switch (cmd)
   {
     case OP_BUY : if (Fish > 0) return(true);
                   break;
     case OP_SELL : if (Fish < 0) return(true);
   }
   
   return(false);
}

void BBStops()
{
     smax1 = smax;
     smin1 = smin;
     smax=iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_UPPER,1);
     smin=iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_LOWER,1);
	
	  PrevTrend=Trend;
	  if (Close[1]>smax1) Trend=1; 
	  if (Close[1]<smin1) Trend=-1;
		 	
	  if(Trend>0 && smin<smin1) smin = smin1;
	  if(Trend<0 && smax>smax1) smax = smax1;
	  	  
	  bsmax1 = bsmax;
     bsmin1 = bsmin;
	  bsmax = smax+0.5*(MoneyRisk-1)*(smax-smin);
	  bsmin = smin-0.5*(MoneyRisk-1)*(smax-smin);
		
	  if(Trend>0 && bsmin<bsmin1) bsmin=bsmin1;
	  if(Trend<0 && bsmax>bsmax1) bsmax=bsmax1; 
 
}
  
bool CheckBBStop(int cmd)
{
   if (UseFunction == 0)
   {
   BBStopUp = iCustom(NULL, Signal_TimeFrame, "BBands_Stop_v2", Length, Deviation, MoneyRisk, 0, 1);
   BBStopDown = iCustom(NULL, Signal_TimeFrame, "BBands_Stop_v2", Length, Deviation, MoneyRisk, 1, 1);
   switch (cmd)
   {
     case OP_BUY : if (BBStopUp > 0 ) return(true);
                   break;
     case OP_SELL : if (BBStopDown > 0) return(true);
   }
   
   return(false);
   }
   BBStops();
   switch (cmd)
   {
     case OP_BUY : if (Close[1] - smax1 > DeltaLong*Point 
                       && PrevTrend<0) return(true);
                   break;
     case OP_SELL : if (smin1 - Close[1] > DeltaShort*Point
                          && PrevTrend>0) return(true);
   }
   
   return(false);
   
}

bool CheckEMA(int cmd)
{
    double ma;
    ma=iMA(NULL,Signal_TimeFrame,EntryMA_Period,0,MODE_EMA,PRICE_CLOSE,1);
    switch (cmd)
    {
       case OP_BUY : if (Close[1] > ma) return(true);
                     break;
       case OP_SELL : if (Close[1] < ma) return(true);
     }
     return(false);
}

void GetMA(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=iMA(NULL,TimeFrame,MAPeriod,0,MODE_EMA,PRICE_CLOSE,Cur);
   MAPrevious=iMA(NULL,TimeFrame,MAPeriod,0,MODE_EMA,PRICE_CLOSE,Prev);
}

void GetLSMA(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=fLSMA(TimeFrame,MAPeriod,Cur);
   MAPrevious=fLSMA(TimeFrame,MAPeriod,Prev);
}

void GetITrend(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=iCustom(NULL,TimeFrame,"Ehlers_iTrend",MAPeriod,0,Cur);
   MAPrevious=iCustom(NULL,TimeFrame,"Ehlers_iTrend",MAPeriod,0,Prev);
}

void GetHMA(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=iCustom(NULL,TimeFrame,"HMA3",MAPeriod,0,0,0,Cur);
   MAPrevious=iCustom(NULL,TimeFrame,"HMA3",MAPeriod,0,0,0,Prev);
}

void GetMA_Trend (int TrendMethod, int myTimeFrame, int myPeriod, int PrevShift, int CurShift)
{
   switch (TrendMethod)
   {
     case EMA_FILTER : GetMA(myTimeFrame,  myPeriod, PrevShift, CurShift);
                      break;
     case LSMA_FILTER :  GetLSMA(myTimeFrame,  myPeriod, PrevShift, CurShift);
                         break;
     case ITREND_FILTER : GetITrend(myTimeFrame,  myPeriod, PrevShift, CurShift);
                          break;
     case HMA_FILTER : GetHMA(myTimeFrame,  myPeriod, PrevShift, CurShift);
   }
}

void GetMACD_H4()
{
   macd_H4=iMACD(NULL,T4_TimeFrame,T4_FastEMA,T4_SlowEMA,T4_SignalSMA,PRICE_CLOSE,MODE_MAIN,T4_SignalCandle); 
   macd_HH4=iMACD(NULL,T4_TimeFrame,T4_FastEMA,T4_SlowEMA,T4_SignalSMA,PRICE_CLOSE,MODE_SIGNAL,T4_SignalCandle); 
}

void GetMACD_H1()
{
   macd_H1=iMACD(NULL,T1_TimeFrame,T1_FastEMA,T1_SlowEMA,T1_SignalSMA,PRICE_CLOSE,MODE_MAIN,T1_SignalCandle); 
   macd_HH1=iMACD(NULL,T1_TimeFrame,T1_FastEMA,T1_SlowEMA,T1_SignalSMA,PRICE_CLOSE,MODE_SIGNAL,T1_SignalCandle); 
}

void GetDIGI_H4()
{
   stoch_main_h4 = iStochastic(NULL,T4_TimeFrame,T4_K_period,T4_D_period,T4_S_period,MODE_SMA,1,MODE_MAIN,T4_SignalCandle);
   stoch_sig_h4 = iStochastic(NULL,T4_TimeFrame,T4_K_period,T4_D_period,T4_S_period,MODE_SMA,1,MODE_SIGNAL,T4_SignalCandle);
}

void GetDIGI_H1()
{
   stoch_main_h1 = iStochastic(NULL,T1_TimeFrame,T1_K_period,T1_D_period,T1_S_period,MODE_SMA,1,MODE_MAIN,T1_SignalCandle);
   stoch_sig_h1 = iStochastic(NULL,T1_TimeFrame,T1_K_period,T1_D_period,T1_S_period,MODE_SMA,1,MODE_SIGNAL,T1_SignalCandle);
}

int Get_Hr_Trend(int cmd)
{
	int Trend;
	bool TrendUP, TrendDOWN;
	double maAngle;
	
   TrendUP = false;
   TrendDOWN = false;
   switch(T1_Method)
   {
      case NO_FILTER :
          TrendUP = true;
          TrendDOWN = true;
          break;
      case MACD_FILTER :
          GetMACD_H1();
          if (macd_H1 > macd_HH1) TrendUP = true;
          if (macd_H1 < macd_HH1) TrendDOWN = true;
          break;
      case DIGI_FILTER :
          GetDIGI_H1();
    //h1 up trend
//    if ((stoch_main_h1 >= stoch_sig_h1) && (stoch_sig_h1 < 20) && (stoch_sig_h1 != 0)) { stoch_color_h1 = YellowGreen; }
//    if ((stoch_main_h1 >= stoch_sig_h1) && (stoch_sig_h1 >= 20) && (stoch_sig_h1 <= 80)) { stoch_color_h1 = Lime; }
//    if ((stoch_main_h1 >= stoch_sig_h1) && (stoch_sig_h1 > 80)) { stoch_color_h1 = Green; }
    
    //h1 down trend
//    if ((stoch_main_h1 <= stoch_sig_h1) && (stoch_sig_h1 > 80) && (stoch_sig_h1 != 100)) { stoch_color_h1 = Tomato; }
//    if ((stoch_main_h1 <= stoch_sig_h1) && (stoch_sig_h1 >= 20) && (stoch_sig_h1 <= 80)) { stoch_color_h1 = Red; }
//    if ((stoch_main_h1 <= stoch_sig_h1) && (stoch_sig_h1 < 20)) { stoch_color_h1 = FireBrick; }

    
          if (stoch_main_h1 >= stoch_sig_h1) TrendUP = true;
          if (stoch_sig_h1 <= stoch_main_h1) TrendDOWN = true;
          break;
      case MACD_DIGI_FILTER :
          GetMACD_H1();
          GetDIGI_H1();
          if (macd_H1 > macd_HH1) TrendUP = true;
          if (TrendUP && (stoch_main_h1 >= stoch_sig_h1)) TrendUP = true; else TrendUP = false;
          if (macd_H1 < macd_HH1) TrendDOWN = true;
          if (TrendDOWN && (stoch_sig_h1 <= stoch_main_h1)) TrendDOWN = true; else TrendDOWN = false;
          break;
      default :
          GetMA_Trend(T1_Method, T1_TimeFrame, T1_Period, T1_PrevShift, T1_CurShift );
	       maAngle = MA_Angle(T1_PrevShift, T1_CurShift, MAPrevious, MACurrent);
          switch (cmd)
          {
             case OP_BUY : if (maAngle > T1_Threshold) TrendUP = true;
                           break;
             case OP_SELL : if (maAngle < -T1_Threshold) TrendDOWN = true;
          }
   }
   
   switch (cmd)
   {
      case OP_BUY : if (TrendUP) return(UP); else return(DOWN);
                    break;
      case OP_SELL : if (TrendDOWN) return(DOWN); else return (UP);

   }
}

int Get_4Hr_Trend (int cmd)
{
	int Trend;
	bool TrendUP, TrendDOWN;
	double maAngle;
	
   TrendUP = false;
   TrendDOWN = false;
   switch(T4_Method)
   {
      case NO_FILTER :
          TrendUP = true;
          TrendDOWN = true;
          break;
      case MACD_FILTER :
          GetMACD_H4();
          if (macd_H4 > macd_HH4) TrendUP = true;
          if (macd_H4 < macd_HH4) TrendDOWN = true;
          break;
      case DIGI_FILTER :
          GetDIGI_H4();
    //h4 up trend
//    if ((stoch_main_h4 >= stoch_sig_h4) && (stoch_sig_h4 < 20) && (stoch_sig_h4 != 0)) { stoch_color_h4 = YellowGreen; }    
//    if ((stoch_main_h4 >= stoch_sig_h4) && (stoch_sig_h4 >= 20) && (stoch_sig_h4 <= 80)) { stoch_color_h4 = Lime; }
//    if ((stoch_main_h4 >= stoch_sig_h4) && (stoch_sig_h4 > 80)) { stoch_color_h4 = Green; }
    
    //h4 down trend
//    if ((stoch_main_h4 <= stoch_sig_h4) && (stoch_sig_h4 > 80) && (stoch_sig_h4 != 100)) { stoch_color_h4 = Tomato; }
//    if ((stoch_main_h4 <= stoch_sig_h4) && (stoch_sig_h4 >= 20) && (stoch_sig_h4 <= 80)) { stoch_color_h4 = Red; }
//    if ((stoch_main_h4 <= stoch_sig_h4) && (stoch_sig_h4 < 20)) { stoch_color_h4 = FireBrick; }
          if (stoch_main_h4 >= stoch_sig_h4) TrendUP = true;
          if (stoch_main_h4 <= stoch_sig_h4) TrendDOWN = true;
          break;
      case MACD_DIGI_FILTER :
          GetMACD_H4();
          GetDIGI_H4();
          if (macd_H4 > macd_HH4) TrendUP = true;
          if (TrendUP && (stoch_main_h4 >= stoch_sig_h4)) TrendUP = true; else TrendUP = false;
          if (macd_H4 < macd_HH4) TrendDOWN = true;
          if (TrendDOWN && (stoch_main_h4 <= stoch_sig_h4)) TrendDOWN = true; else TrendDOWN = false;
          break;
      default :
          GetMA_Trend(T4_Method, T4_TimeFrame, T4_Period , T4_PrevShift, T4_CurShift);
	       maAngle = MA_Angle(T4_PrevShift, T4_CurShift, MAPrevious, MACurrent);
          switch (cmd)
          {
             case OP_BUY : if (maAngle > T4_Threshold) TrendUP = true;
                           break;
             case OP_SELL : if (maAngle < -T4_Threshold) TrendDOWN = true;
          }
   }
   switch (cmd)
   {
      case OP_BUY : if (TrendUP) return(UP); else return(DOWN);
                    break;
      case OP_SELL : if (TrendDOWN) return(DOWN); else return (UP);

   }
 }
 
 bool CheckTrend(int cmd)
{
	int trend1, trend4;
   
   switch (cmd)
   {
     case OP_BUY : trend1 = Get_Hr_Trend(OP_BUY);
                   if (trend1 == UP)
                   {
                       trend4 = Get_4Hr_Trend(OP_BUY);
                       if (trend4 == UP) return(true);
                   }
                   return(false);
                   break;
     case OP_SELL : trend1 = Get_Hr_Trend(OP_SELL);
                   if (trend1 == DOWN)
                   {
                       trend4 = Get_4Hr_Trend(OP_SELL);
                       if (trend4 == DOWN) return(true);
                   }
                   return(false);
    }
    return(false);
}

//+------------------------------------------------------------------+
//| CheckExitCondition                                               |
//| Uses OP_BUY as cmd to check exit sell                            |
//| Uses OP_SELL as cmd to check exit buy                            |
//+------------------------------------------------------------------+
bool CheckExitCondition(int cmd)
{
   bool rule1, rule2, rule3, rule4, rule5;
   
   rule1 = true;
   rule2 = true;
   rule3 = true;
   rule4 = true;
   rule5 = true;
   
// The rules are checked this way for speed

   if (useHeikenAshiExit == 1) rule1 = CheckHeikenAshi(cmd);
   if (rule1)
   {
     if (useStepMAExit == 1) rule2 = CheckStepMA(cmd);
     if (rule2)
     {
       if (useFishExit == 1) rule3 = CheckFish(cmd);
       if (rule3)
       {
         if (useBBStopExit == 1) rule4 = CheckBBStop(cmd);
         if (rule4)
         {
            if (useTrend == 1) rule5 = CheckTrend(cmd);
            if (rule5) return (true);
         }
       }
     }
   }
   
   return (false);
}

//+------------------------------------------------------------------+
//| CheckEntryCondition                                              |
//+------------------------------------------------------------------+
bool CheckEntryCondition(int cmd)
{
   bool rule0, rule1, rule2, rule3, rule4, rule5;
   
   rule0 = true;
   rule1 = true;
   rule2 = true;
   rule3 = true;
   rule4 = true;
   rule5 = true;
   
// The rules are checked this way for speed
  
   if (useTrend == 1) rule0 = CheckTrend(cmd);
   if (rule0)
   {
     if (useHeikenAshi == 1) rule1 = CheckHeikenAshi(cmd);
     if (rule1)
     {
       if (useBBStop == 1) rule2 = CheckBBStop(cmd);
       if (rule2)
       {
         if (useFish == 1) rule3 = CheckFish(cmd);
         if (rule3)
         {
           if (useStepMA == 1) rule4 = CheckStepMA(cmd);
           if (rule4)
           {
             if (useEMA == 1) rule5 = CheckEMA(cmd);
             if (rule5) return(true);
           }
         }
       }
     }
   }
   
   return (false);
}
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
   
//+------------------------------------------------------------------+
//| Check for Open Position                                          |
//+------------------------------------------------------------------+

     HandleOpenPositions();
     
// Check if any open positions were not closed

     TradesInThisSymbol = CheckOpenPositions();
     
//+------------------------------------------------------------------+
//| Check if OK to make new trades                                   |
//+------------------------------------------------------------------+


   if(AccountFreeMargin() < Margincutoff) {
     return(0);}

   if (UseTradingHours)
   {

     YesStop = true;
// Check trading Asian Market
     if (TradeAsianMarket)
     {
        if (Hour() >= StartHour1 && Hour() <= StopHour1) YesStop = false;
     }
     if (YesStop)
     {
// Check trading European Market
       if (TradeEuropeanMarket)
       {
         if (Hour() >= StartHour2 && Hour() <= StopHour2) YesStop = false;
       }
     }
     if (YesStop)
     {
// Check trading European Market
       if (TradeNewYorkMarket)
       {
         if (Hour() >= StartHour3 && Hour() <= StopHour3) YesStop = false;
       }
     }
     if (YesStop)
     {
//      Comment ("Trading has been stopped as requested - wrong time of day");
       return (0);
      }
   }
     
// Only allow 1 trade per Symbol

     if(TradesInThisSymbol > 0) {
       return(0);}
   

   lotMM = GetLots();
   
      
	if(CheckEntryCondition(OP_BUY))
	{
		   OpenBuyOrder();
		   return(0);
	}

   
	if(CheckEntryCondition(OP_SELL))
	{
         OpenSellOrder();
	}
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Functions beyond this point should not need to be modified       |
//| Eventually will be placed in include file                        |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| OpenBuyOrder                                                     |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenBuyOrder()
{
   int err,ticket, digits;
   double myPrice, myStopLoss = 0, myTakeProfit = 0;
   
   myPrice = MarketInfo(Symbol(), MODE_ASK);
   myStopLoss = 0;
   if ( StopLoss > 0 ) myStopLoss = myPrice - StopLoss * Point ;
   myTakeProfit = 0;
   if (TakeProfit>0) myTakeProfit = myPrice + TakeProfit * Point;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
   digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
   if (digits > 0) 
   {
     myPrice = NormalizeDouble( myPrice, digits);
     myStopLoss = NormalizeDouble( myStopLoss, digits);
     myTakeProfit = NormalizeDouble( myTakeProfit, digits); 
   }
   ticket=OrderSend(Symbol(),OP_BUY,lotMM,myPrice,Slippage,myStopLoss,myTakeProfit,setup,MagicNumber,0,Green); 
   if (ticket > 0)
   {
    if (OrderSelect( ticket,SELECT_BY_TICKET, MODE_TRADES) ) 
     {
      Print("BUY order opened : ", OrderOpenPrice( ));
//      ModifyOrder(ticket,OrderOpenPrice( ), OrderStopLoss(), myTakeProfit);
    }
   }
   else
   {
      err = GetLastError();
      Print("Error opening BUY order [" + setup + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}

//+------------------------------------------------------------------+
//| OpenSellOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenSellOrder()
{
   int err, ticket, digits;
   double myPrice, myStopLoss = 0, myTakeProfit = 0;
   
   myPrice = MarketInfo(Symbol( ), MODE_BID);
   myStopLoss = 0;
   if ( StopLoss > 0 ) myStopLoss = myPrice + StopLoss * Point;
   myTakeProfit = 0;
   if (TakeProfit > 0) myTakeProfit = myPrice - TakeProfit * Point;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
   digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
   if (digits > 0) 
   {
     myPrice = NormalizeDouble( myPrice, digits);
     myStopLoss = NormalizeDouble( myStopLoss, digits);
     myTakeProfit = NormalizeDouble( myTakeProfit, digits); 
   }
   ticket=OrderSend(Symbol(),OP_SELL,lotMM,myPrice,Slippage,myStopLoss,myTakeProfit,setup,MagicNumber,0,Red); 
   if (ticket > 0)
   {
     if (OrderSelect( ticket,SELECT_BY_TICKET, MODE_TRADES) ) 
     {
      Print("Sell order opened : ", OrderOpenPrice());
//      ModifyOrder(ticket,OrderOpenPrice( ), OrderStopLoss(), myTakeProfit);
     }
   }
   else
   {
      err = GetLastError();
      Print("Error opening Sell order [" + setup + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}

//+------------------------------------------------------------------+
//| Check Open Position Controls                                     |
//+------------------------------------------------------------------+
  
int CheckOpenPositions()
{
   int cnt, total, NumPositions;
   int NumBuyTrades, NumSellTrades;   // Number of buy and sell trades in this symbol
   
   NumBuyTrades = 0;
   NumSellTrades = 0;
   total=OrdersTotal();
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
     {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY )  NumBuyTrades++;
      if(OrderType() == OP_SELL ) NumSellTrades++;
             
     }
     NumPositions = NumBuyTrades + NumSellTrades;
     return (NumPositions);
  }

int CloseOrder(int ticket,double numLots,int cmd)
{
   int CloseCnt, err, digits;
   double myPrice;
   
   if (cmd == OP_BUY) myPrice = MarketInfo(Symbol( ), MODE_BID);
   if (cmd == OP_SELL) myPrice = MarketInfo(Symbol( ), MODE_ASK);
   digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
   if (digits > 0)  myPrice = NormalizeDouble( myPrice, digits);
   // try to close 3 Times
      
    CloseCnt = 0;
    while (CloseCnt < 3)
    {
       if (!OrderClose(ticket,numLots,myPrice,Slippage,Violet))
       {
         err=GetLastError();
         Print(CloseCnt," Error closing order : (", err , ") " + ErrorDescription(err));
         if (err > 0) CloseCnt++;
       }
       else
       {
         CloseCnt = 3;
       }
    }
}

int ModifyOrder(int ord_ticket,double op, double price,double tp)
{
    int CloseCnt, err;
    
    CloseCnt=0;
    while (CloseCnt < 3)
    {
       if (OrderModify(ord_ticket,op,price,tp,0,Aqua))
       {
         CloseCnt = 3;
       }
       else
       {
          err=GetLastError();
          Print(CloseCnt," Error modifying order : (", err , ") " + ErrorDescription(err));
         if (err>0) CloseCnt++;
       }
    }
}

//+------------------------------------------------------------------+
//| HandleTrailingStop                                               |
//| Type 1 moves the stoploss without delay.                         |
//| Type 2 waits for price to move the amount of the trailStop       |
//| before moving stop loss then moves like type 1                   |
//| Type 3 uses up to 3 levels for trailing stop                     |
//|      Level 1 Move stop to 1st level                              |
//|      Level 2 Move stop to 2nd level                              |
//|      Level 3 Trail like type 1 by fixed amount other than 1      |
//| Possible future types                                            |
//| Type 4 uses 2 for 1, every 2 pip move moves stop 1 pip           |
//| Type 5 uses 3 for 1, every 3 pip move moves stop 1 pip           |
//+------------------------------------------------------------------+
int HandleTrailingStop(int type, int ticket, double op, double os, double tp)
{
    int digits;
    double pt, TS;
    double myPrice;
    
    digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
    if (type == OP_BUY)
    {
        myPrice = MarketInfo(Symbol( ), MODE_BID);
        pt = Point*TrailingStop;
        TS = myPrice - pt;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
        if (digits > 0) TS = NormalizeDouble( TS, digits);
        if(myPrice-op > pt && os < TS) ModifyOrder(ticket,op,TS,tp);
        return(0);
    }
       
    if (type ==  OP_SELL)
    {
        myPrice = MarketInfo(Symbol( ), MODE_ASK);
        pt = Point*TrailingStop;
        TS = myPrice + pt;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
        if (digits > 0) TS = NormalizeDouble(TS, digits); 
        if(op - myPrice > pt && os > TS) ModifyOrder(ticket,op,TS,tp);
    }
    return(0);
}


//+------------------------------------------------------------------+
//| Handle Open Positions                                            |
//| Check if any open positions need to be closed or modified        |
//+------------------------------------------------------------------+
int HandleOpenPositions()
{
   int cnt;
   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY)
      {
            
         if (CheckExitCondition(OP_SELL))
          {
              CloseOrder(OrderTicket(),OrderLots(),OP_BUY);
          }
          else
          {
            if (UseTrailingStop)
            {
               HandleTrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
            }
          }
      }

      if(OrderType() == OP_SELL)
      {
          if (CheckExitCondition(OP_BUY))
          {
             CloseOrder(OrderTicket(),OrderLots(),OP_SELL);
          }
          else
          {
            if (UseTrailingStop)
            {
               HandleTrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
            }
          }
      }
   }
}

     
//+------------------------------------------------------------------+
//| Get number of lots for this trade                                |
//+------------------------------------------------------------------+
double GetLots()
{
   double lot;
   
   if(MoneyManagement)
   {
     lot = LotsOptimized();
   }
   else
   {
     lot = Lots;
   }
   
   if(AccountIsMini)
   {
     if (lot < 0.1) lot = 0.1;
   }
   else
   {
     if (lot >= 1.0) lot = MathFloor(lot); else lot = 1.0;
   }
   if (lot > MaxLots) lot = MaxLots;
   
   return(lot);
}

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+

double LotsOptimized()
  {
   double lot=Lots;
//---- select lot size
   lot=NormalizeDouble(MathFloor(AccountFreeMargin()*TradeSizePercent/10000)/10,1);
   
  
  // lot at this point is number of standard lots
  
//  if (Debug) Print ("Lots in LotsOptimized : ",lot);
  
  // Check if mini or standard Account
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
    
   }
   return(lot);
  }

//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                      |
//+------------------------------------------------------------------+

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}

//+------------------------------------------------------------------+
//| Time frame string appropriation  function                               |
//+------------------------------------------------------------------+

string func_TimeFrame_Val2String(int Value ) {
   switch(Value) {
      case 1:  // M1
         return("PERIOD_M1");
      case 2:  // M1
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " + Value);
   }
}

int func_Symbol2Val(string symbol)
 {
   string mySymbol = StringSubstr(symbol,0,6);
	if(mySymbol=="AUDCAD") return(1);
	if(mySymbol=="AUDJPY") return(2);
	if(mySymbol=="AUDNZD") return(3);
	if(mySymbol=="AUDUSD") return(4);
	if(mySymbol=="CHFJPY") return(5);
	if(mySymbol=="EURAUD") return(6);
	if(mySymbol=="EURCAD") return(7);
	if(mySymbol=="EURCHF") return(8);
	if(mySymbol=="EURGBP") return(9);
	if(mySymbol=="EURJPY") return(10);
	if(mySymbol=="EURUSD") return(11);
	if(mySymbol=="GBPCHF") return(12);
	if(mySymbol=="GBPJPY") return(13);
	if(mySymbol=="GBPUSD") return(14);
	if(mySymbol=="NZDUSD") return(15);
	if(mySymbol=="USDCAD") return(16);
	if(mySymbol=="USDCHF") return(17);
	if(mySymbol=="USDJPY") return(18);
   Comment("unexpected Symbol");
	return(19);
}

